### 节点输出定义

##### 格式为schema

每个节点输出值为 默认输出值和附加输出值
每个属性使用 nodeType 标识输出值类型

当前类型: 
| key | name |
| ------ | ------ |
| node | 资产 |
| model | 模型 |
| modelDataPoint | 模型数据点 |
| nodeDataPoint | 资产数据点 |
| modelProperties | 模型属性 |
| nodeProperties | 资产属性 |
| table | 工作表 |
| department | 部门 |
| user | 用户 |
| systemVariable | 系统变量 |
| systemTime | 系统事件 |

#####  在schema中使用流程变量

思路: 
1. **文本字段**绑定流程变量，可以输入多个变量或字符串进行计算/逻辑判断(需后端服务支持)
2. **非文本字段**绑定流程变量，只可以单选/多选变量。

使用方法：
配置extendFlow

```
show      {boolean} 是否启用
type      {string}  分类         可用属性 model/node/user/department/table/dataPoint 默认是属性绑定
                                 model/node/user/department: 针对特殊绑定字段配置，仅返回模型/资产/用户/部门,不包含属性
                                 dataPoint: 仅会过滤出前序节点输出的数据点类型(nodeDataPoint/modelDataPoint)属性
limit     {array}   字段属性限制   可用属性 ['string', 'boolean', 'number','time', 'attachment'] 默认无限制
                                 string/boolean/number: 会过滤出已明确类型为(string/boolean/number)的选项，包含前序节点输出值(输出值类型未知所以不做过滤)
                                 time: 特殊字符串字段, 仅过滤出schema中type为string且有format的属性 
                                 attachment: 待定 
                                 limit只针对属性绑定模式生效
          {function} 可以接受一个方法，此方法会在变量选择器挂载时执行，可以拿到每一个变量的定义，此方法返回布尔值决定传入的变量是否在变量选择器中展示                       
mode      {string}  模式         可用属性 'single'(单选) / 'multiple'(多选)          默认值'single'
                                 多选模式仅支持 type为值为'model'/'node'/'user'/'department'/'dataPoint'之一时 
                                 多选模式时 默认type值为 dataPoint

```

例如: 

```
schema = {
  type: 'object',
  properties: {
    example: {
      type: 'string',
      title: '例如',
      field:{
        extendFlow:{
            show: true,
            type:'node'
        }
      }
    }
  }
}
```
##### 注册节点自定义必填项校验

- 默认校验： 节点必填项校验默认根据节点配置的paramSchema属性以及右侧表单的值，在表单值变化时校验。
- 自定义校验： 在注册节点时可以添加requiredInfo方法自定义校验规则，参数node为当前节点对象，返回值为字符串或空，空值为校验通过，非空字符串会提示在组件下方。

例如：
```
{
  title: '自定节点A',
  icon: '',
  category: ['处理节点', '数据节点A'],
  component: () => 'customA',
  requiredInfo: node => {
    return '未填写所有信息'
  },
  paramSchema,
  style
}
```
##### 注册节点自定义添加、连接权限

使用方法：
在注册节点时可以添加permission自定义该节点能在哪些流程中使用。

permission类型：
- 数组： 定义该节点能在开始节点为哪些节点的流程中添加、连接。

例如：
```
{
  title: '自定节点A',
  icon: '',
  category: ['处理节点', '数据节点A'],
  component: () => 'customA',
  permission: ['工作表事件'],
  paramSchema,
  style
}
```
- 方法： 参数包括elements流程中的节点和边、params连接节点参数，返回值为字符串或空，空值为校验通过，非空字符串为添加、连接失败提示。

例如：
```
{
  title: '自定节点A',
  icon: '',
  category: ['处理节点', '数据节点A'],
  component: () => 'customA',
  permission: (elements, params) => {
    return '不能连接此节点'
  },
  paramSchema,
  style
}
```
